<?php
/*
Plugin Name: Social Metrics for Japanese
Plugin URI: http://kachibito.net
Description: Track how your blog is doing across the leading social networking websites and services like Twitter, Facebook, Google +1, Hatena.
Author: Shiro
Version: 1.0
Author URI: http://kachibito.net
License: GPL2
*/

/*  Copyright 2010  Riyaz Sayyad  (email : riyaz@riyaz.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


http://www.riyaz.net/social-metrics/ より、
一部ソース変更再配布されたものをさらに修正して再配布

kachibito.net
2011/06/13

iwb.jp
2014/09/01

*/
?>
<?php
function socialmetrics_init() { ?>
<?php }
add_action('init', 'socialmetrics_init');
?>
<?php
function add_socialmetrics_scripts(){ ?>
	<script type="text/javascript" src="http://platform.twitter.com/widgets.js"></script>
	<script type="text/javascript" src="http://apis.google.com/js/plusone.js"></script>
<?php
}
?>
<?php
// create custom plugin settings menu
add_action('admin_menu', 'socialmetrics_create_menu');
function socialmetrics_create_menu() {
	//create new top-level menu
	add_submenu_page('plugins.php', 'Social Metrics Settings', 'Social Metrics', 'administrator', 'socialmetrics_settings', 'socialmetrics_settings_page' );
	//call register settings function
	add_action( 'admin_init', 'register_socialmetrics_settings' );
	add_submenu_page( 'index.php', 'Social Metrics', 'Social Metrics', 'administrator', 'socialmetrics_dashboard', 'socialmetrics_dashboard_page' );
}

function socialmetrics_adminbar() {
	global $wp_admin_bar;
    if ( !is_super_admin() || !is_admin_bar_showing() ) { return; }
	$href = add_query_arg( 'page', 'socialmetrics_dashboard', admin_url() );
    $wp_admin_bar->add_menu( array(
    'id' => 'socialmetrics_dashboard',
    'title' => __( 'Social Metrics', 'socialmetrics_dashboard' ),
    'href' => $href ) );
}
add_action( 'admin_bar_menu', 'socialmetrics_adminbar', 100 );

function register_socialmetrics_settings() {
	//register the settings
	register_setting( 'socialmetrics-settings-group', 'socialmetrics_per_page' );
}

function socialmetrics_dashboard_page() {
?>
<script type="text/css"></script>
<link rel="stylesheet" type="text/css" href="mystyle.css" />
<?php
if ( !isset($_GET['p_type']) ) { $post_type = 'post'; }
elseif ( in_array( $_GET['p_type'], get_post_types( array('show_ui' => true ) ) ) ) {
	$post_type = $_GET['p_type']; }
else {
	wp_die( __('Invalid post type') ); }

$_GET['p_type'] = $post_type;

$post_type_object = get_post_type_object($post_type);
?>
<div class="wrap">
	<h2>Social Metrics for Japanese Dashboard: <?php bloginfo('name'); ?></h2>
	<div style="float:left;margin-bottom:5px;margin-top:5px;">Metrics That Count | 本家: <a style="text-decoration:none;"href="http://www.riyaz.net" target="_blank">riyaz.net</a> / 日本語化: <a style="text-decoration:none;"href="http://kachibito.net" target="_blank">kachibito.net</a> 再改良: <a style="text-decoration:none;"href="http://iwb.jp/" target="_blank">iwb.jp</a></div>
	<div style="float:right;margin-bottom:5px;"></div>
<?php
	$per_page = get_option('socialmetrics_per_page', 15);
	if ( $per_page == 0 ) { $per_page = 15; }

	$paged = $_GET['paged'];
	$s_cat = $_GET['s_cat'];

	if (isset( $_GET['s_mon'] )) {
		$s_mon = $_GET['s_mon'];
		if (strlen($s_mon) == 6) {
		$s_month = substr($s_mon,4,6);
		$s_year = substr($s_mon,0,4);
		}
	}

	$pagenum = isset( $_GET['paged'] ) ? absint( $_GET['paged'] ) : 0;
	if ( empty($pagenum) ){ $pagenum = 1; }
	
    $recentPosts = new WP_Query();

	if ( 'post' != $post_type ) {
		$current_ptype = 'Pages';
		$recentPosts->query('showposts='.$per_page.'&post_status=publish'.'&paged='.$paged.'&post_type=page'.'&year='. $s_year . '&monthnum='.$s_month );
	}else {
		$current_ptype = 'Posts';
		$recentPosts->query('showposts='.$per_page.'&post_status=publish'.'&paged='.$paged.'&cat='.$s_cat.'&year='. $s_year . '&monthnum='.$s_month );
	}
?>
	<div class="tablenav">
<?php
		$num_pages = $recentPosts->max_num_pages;	
?>
<?php
		$page_links = paginate_links( array(
			'base' => add_query_arg( 'paged', '%#%' ),
			'format' => '',
			'prev_text' => __('&laquo;'),
			'next_text' => __('&raquo;'),
			'total' => $num_pages,
			'current' => $pagenum
		));
?>
		<div class="tablenav-pages" style="float: left;">
<?php 
			$s_uri = $_SERVER['REQUEST_URI']; 
			$s_uri = esc_url(remove_query_arg(array('paged','p_type','s_cat','s_mon'), $s_uri ));
?>
			<a href="<?php echo esc_url(add_query_arg('p_type', 'post', $s_uri )) ?>"><span class="page-numbers">全記事を見る</span></a>
			<a href="<?php echo esc_url(add_query_arg('p_type', 'page', $s_uri )) ?>"><span class="page-numbers">全投稿ページを見る</span></a>	
<?php 
			$s_uri = $_SERVER['REQUEST_URI']; 
			$s_uri = remove_query_arg(array('paged','p_type','s_cat'), $s_uri );
			$s_uri = add_query_arg('page', 'socialmetrics_dashboard', $s_uri );

			if ( is_object_in_taxonomy($post_type, 'category') && ( 'post' == $post_type ) ) {
				$dropdown_options = array('show_option_none' => __('カテゴリ別で見る'), 'hide_empty' => 0, 'hierarchical' => 1,'show_count' => 0, 'orderby' => 'name', 'selected' => $s_cat);
				wp_dropdown_categories($dropdown_options); ?>
				<script type="text/javascript"><!--
				var dropdown = document.getElementById("cat");
				function onCatChange() {
					if ( dropdown.options[dropdown.selectedIndex].value > 0 ) {
						location.href = "<?php echo $s_uri ?>&s_cat="+dropdown.options[dropdown.selectedIndex].value;
					}
				}
				dropdown.onchange = onCatChange;
				--></script>
<?php		} ?>
<?php 
			global $wpdb;
			global $wp_locale;

			if ( !is_singular() ) {
				$s_uri = $_SERVER['REQUEST_URI']; 
				$s_uri = remove_query_arg(array('paged','s_mon'), $s_uri );
				$s_uri = add_query_arg('page', 'socialmetrics_dashboard', $s_uri );

				$arc_query = $wpdb->prepare("SELECT DISTINCT YEAR(post_date) AS yyear, MONTH(post_date) AS mmonth FROM $wpdb->posts WHERE post_type = %s ORDER BY post_date DESC", $post_type);
				$arc_result = $wpdb->get_results( $arc_query );
				$month_count = count($arc_result);

				if ( $month_count && !( 1 == $month_count && 0 == $arc_result[0]->mmonth ) ) {
					$m = isset($_GET['s_mon']) ? (int)$_GET['s_mon'] : 0;
?>
					<select name='m' id='m'>
						<option<?php selected( $m, 0 ); ?> value='0'><?php _e('月別で見る'); ?></option>
<?php
						foreach ($arc_result as $arc_row) {
							if ( $arc_row->yyear == 0 ) { continue; }
							$arc_row->mmonth = zeroise( $arc_row->mmonth, 2 );

							if ( $arc_row->yyear . $arc_row->mmonth == $m ) {
								$default = ' selected="selected"'; }
							else {
								$default = ''; }

							echo "<option$default value='" . esc_attr("$arc_row->yyear$arc_row->mmonth") . "'>";
							echo " $arc_row->yyear";
							echo "年  　";
							echo $wp_locale->get_month($arc_row->mmonth);
							echo "</option>\n";
						}
?>					</select>
					<script type="text/javascript"><!--
					var dropdown_m = document.getElementById("m");
					function onMonthChange() {
						if ( dropdown_m.options[dropdown_m.selectedIndex].value > 0 ) {
							location.href = "<?php echo $s_uri ?>&s_mon="+dropdown_m.options[dropdown_m.selectedIndex].value;
						}
					}
					dropdown_m.onchange = onMonthChange;
					--></script>
<?php 			} ?>
<?php 		} ?>
		</div>
		<div class="tablenav-pages">
<?php 		if ( $page_links ) { ?>
<?php
				$count_posts = $recentPosts->found_posts;
				$page_links_text = sprintf( '<span class="displaying-num">' . __( '%s %s&#8211;%s of %s' ) . '</span>%s',
									$current_ptype,
									number_format_i18n( ( $pagenum - 1 ) * $per_page + 1 ),
									number_format_i18n( min( $pagenum * $per_page, $count_posts ) ),
									number_format_i18n( $count_posts ),
									$page_links
									);
				echo $page_links_text;
			}
?>
		</div>
	</div>
	<div class="clear"></div>
	<table class="widefat post fixed" cellspacing="0">
		<thead>
			<tr>
				<th scope="col" id="title0" class="manage-column column-title" style="border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Title</th>
				<th scope="col" id="title1" class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Twitter</th>
				<th scope="col" id="title2" class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Facebook</th>
				<th scope="col" id="title3" class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Hatena</th>
				<th scope="col" id="title4" class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Google +1</th>
				<th scope="col" id="title5" class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Pocket</th>
			</tr>
		</thead>
		<tbody>
<?php 		while ($recentPosts->have_posts()) : $recentPosts->the_post(); ?>
			<tr>
				<td style="border-right: 1px solid #DFDFDF;border-right-spacing: 0;"><a href="<?php the_permalink() ?>" rel="bookmark"><?php the_title(); ?></a></td>
				<td style="text-align:center;vertical-align: middle;border-right: 1px solid #DFDFDF;border-right-spacing: 0;"><a href="http://twitter.com/share" class="twitter-share-button" data-text="<?php the_title(); ?>" data-count="horizontal" data-url="<?php the_permalink() ?>">Tweet</a></td>
				<td style="text-align:center;vertical-align: middle;border-right: 1px solid #DFDFDF;border-right-spacing: 0;"><iframe src="http://www.facebook.com/plugins/like.php?href=<?php the_permalink() ?>&send=false&layout=button_count&width=100&show_faces=false&action=like&colorscheme=light" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:100px; height:21px;" allowTransparency="true"></iframe></td>
				<td style="text-align:center;vertical-align: middle;border-right: 1px solid #DFDFDF;border-right-spacing: 0;"><a href="http://b.hatena.ne.jp/entry/<?php the_permalink() ?>" class="hatena-bookmark-button" data-hatena-bookmark-layout="standard" title="このエントリーをはてなブックマークに追加"><img src="http://b.st-hatena.com/images/entry-button/button-only.gif" alt="このエントリーをはてなブックマークに追加" width="20" height="20" style="border: none;" /></a><script type="text/javascript" src="http://b.st-hatena.com/js/bookmark_button.js" charset="utf-8" async="async"></script></td>
				<td style="text-align:center;vertical-align: middle;border-right: 1px solid #DFDFDF;border-right-spacing: 0;"><g:plusone size="medium" href="<?php the_permalink() ?>"></g:plusone></td>
				<td style ="text-align:center;vertical-align: middle;border-right: 1px solid #DFDFDF;border-right-spacing: 0;"><a data-pocket-label="pocket" data-pocket-count="horizontal" class="pocket-btn" data-lang="en" data-save-url="<?php the_permalink() ?>"></a><script type="text/javascript">!function(d,i){if(!d.getElementById(i)){var j=d.createElement("script");j.id=i;j.src="https://widgets.getpocket.com/v1/j/btn.js?v=1";var w=d.getElementById(i);d.body.appendChild(j);}}(document,"pocket-btn-js");</script></td>
			</tr>
<?php		endwhile; ?>
		</tbody>
		<tfoot>
			<tr>
				<th scope="col"  class="manage-column column-title" style="border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Title</th>
				<th scope="col"  class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Twitter</th>
				<th scope="col"  class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Facebook</th>
				<th scope="col"  class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Hatena</th>
				<th scope="col"  class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Google +1</th>
				<th scope="col"  class="manage-column column-title" style="text-align:center;border-right: 1px solid #DFDFDF;border-right-spacing: 0;">Pocket</th>
			</tr>
		</tfoot>
	</table>
	<div class="tablenav">
		<div class="tablenav-pages">
      <?php if ( $page_links ) {
				$count_posts = $recentPosts->found_posts;
				$page_links_text = sprintf( '<span class="displaying-num">' . __( '%s %s&#8211;%s of %s' ) . '</span>%s',
									$current_ptype,
									number_format_i18n( ( $pagenum - 1 ) * $per_page + 1 ),
									number_format_i18n( min( $pagenum * $per_page, $count_posts ) ),
									number_format_i18n( $count_posts ),
									$page_links
									);
				echo $page_links_text;
			} ?>
		</div>
	</div>
</div>
<?php
add_socialmetrics_scripts();
}

function socialmetrics_settings_page() {
?>
<div class="wrap">
	<h2>Social Metrics Settings</h2>
	<?php
	global $wp_query;
	$adm_url = admin_url();

	if( $_GET['updated'] ) { ?>
		<div id="message" class="updated">You are all set! Go to your <a href="<?php echo $adm_url . 'index.php?page=socialmetrics_dashboard' ; ?>">Social Metrics Dashboard</a>.</div>
	<?php } ?>

	<form method="post" action="options.php">
		<?php settings_fields( 'socialmetrics-settings-group' ); ?>
		<div style="background:#deeefe;float:right; margin:10px 10px 10px 10px; padding:5px; width:50%;">
			<div style="margin-left:10px;">
				<h3>Who Created the	Social Metrics?</h3>
					<div>The <a href="http://www.riyaz.net/social-metrics/" target="_blank" style="text-decoration:none;font-weight:bold;">Social Metrics</a> plugin for WordPress is created by <a href="http://www.riyaz.net/about/" target="_blank" style="text-decoration:none;">Riyaz</a>. Riyaz blogs at <a href="http://www.riyaz.net" target="_blank" style="text-decoration:none;font-weight:bold;">riyaz.net</a>.<br></br></div>
					<iframe allowtransparency="true" frameborder="0" scrolling="no" src="http://platform.twitter.com/widgets/follow_button.html?screen_name=riyaznet&show_count=true" style="width:300px; height:20px;"></iframe><br></br>
					<iframe src="http://www.facebook.com/plugins/like.php?href=http%3A%2F%2Fwww.facebook.com%2Friyaznet&amp;send=false&amp;layout=standard&amp;width=450&amp;show_faces=true&amp;action=like&amp;colorscheme=light&amp;font&amp;height=80" scrolling="no" frameborder="0" style="border:none; overflow:hidden; width:450px; height:80px;" allowTransparency="true"></iframe>
					<br><script type="text/javascript" src="http://apis.google.com/js/plusone.js"></script>
					<g:plusone size="medium" href="http://www.riyaz.net/"></g:plusone>
				<h3>Need Help?</h3>
					For Help, Support, Bugs, Feedback, Suggestions, Feature requests, please visit <a href="http://www.riyaz.net/social-metrics/" style="text-decoration:none;" target="_blank">Social Metrics Homepage</a> or reach me through <a href="http://www.riyaz.net/contact/" target="_blank" style="text-decoration:none;">contact options</a>.
				<h3>Our Social Media Plugins You May Like</h3>
					<ul><li><a href="http://www.riyaz.net/getsocial/" target="_blank" style="text-decoration:none;font-weight:bold;">GetSocial</a> - Make your blog more social. Add a lightweight and intelligent <em><u>floating social media sharing box</u></em> on your blog posts.</li>
					<li><a href="http://www.riyaz.net/wp-tweetbox/" target="_blank" style="text-decoration:none;font-weight:bold;">WP Tweetbox</a> - Add Twitter Power to your blog. Add a highly customizable Tweetbox to your blog posts and pages. <em><u>Brand your tweets</u></em> with your own website URL.</li>
					</ul>
			</div>
		</div>
		<div style="float:left;width:40%;">
			<div style="margin-left:10px;">
				<h3>Options</h3>
					<table>
						<tr valign="middle">
							<td>表示する記事数</td>
							<td>&nbsp;&nbsp;&nbsp;<input type="text" name="socialmetrics_per_page" value="<?php echo get_option('socialmetrics_per_page', 15); ?>" style="width: 50px;" />&nbsp;(デフォルト: <strong>15記事</strong>).</td>
						</tr>
					</table>
				<p class="submit">
				<input type="submit" class="button-primary" value="<?php _e('保存') ?>" />
				</p>
			</div>
		</div>
	</form>
</div>
<?php } ?>